//
// Lex ev[g for Delphi
//      by Osamu TAKEUCHI <osamu@big.or.jp>
//         http://www2.big.or.jp/~osamu/
//
//
//   Lex ev[ggƁAb͂ TLex ƂNX
//  ܂ރjbg *.L t@C玩邱Ƃł܂B
//
//  TLex ͂̃ev[gƂƂɔzz LexLib Ɏ TLexBase
//  NX̎qƂȂ܂B
//
//  ALexLib.TLexBase ͉zNXƂĐ錾܂̂ŁAۂ̓o͂
//  A܂ȂJX^}CY邽 TLexBase hNX
//  pӂATLex ͂̃NXhKv܂B
//
//  R[h́Apꂽ LexLib.TLexBase ̎qNXK
//  SomeUnit.TLexBase ̌`̖O̂Ɖ肵܂B
//
//  TStream y string ɑ΂o͂s TLexBase  LexLib_Stream jbg
//  Ă܂Bʏ̗prɂ͂gpΗp邩܂B
//
//  .L  definitions ZNVɂ͕K
//  %{
//      unit UnitName;
//      interface
//      uses SomeLexLib, MyYacc;
//  %}
//  ̂TsLqĂB
//  UnitName  *.l t@C * ƓO
//  SomeLexLib ͎ۂ̓o̓[` TLexBase NX񋟂郆jbg
//  MyYacc  *.l Ƒgݍ킹Ďg *.y t@C琶郆jbg
//  ̑Kvȃjbg uses 邱Ƃł܂
//  ̑KvȃO[o錾ɒǉ邱Ƃł܂
//
//  .L  rules ZNV̐擪 TLex ̃o[錾ǉ邱Ƃł܂B
//    private
//      procedure SomeUtility;
//  sɃzCgXy[XȂ΂ȂȂƂɒӂĂB
//
//  .L  axiliary procedures ZNVɂ rules ZNVŒǉ錾
//  Ή`Ƃł܂B
//      procedure TLex.SomeUtility;
//      begin
//
//      end;
//
//  oオ SomeLex.pas jbĝ͎悤ɂĎgƂł܂B
//  ł TLexBase Ƃ LexLib_Stream.TLexBase gpƉ肵܂B
//
//    uses
//      SomeLex,        // lex  ɂ SomeLex.l  玩
//      SomeYacc;       // yacc ɂ SomeYacc.y 玩
//
//    var lex: TLex;    // lex  ɂ莩ꂽ SomeLex  Ɏ
//        yacc: TYacc;  // yacc ɂ莩ꂽ SomeYacc Ɏ
//    begin
//        lex := nil;
//        yacc:= nil;
//        try
//            lex := TLex.Create;
//            lex.InputString:= 'x=2*(3+2)'#10'x*3'#10;
//            yacc:= TYacc.Create(lex); // yacc  lex 蓖Ă
//            yacc.yyparse;             // p[XsI
//        finally
//            yacc.Free;
//            lex.Free;
//        end;
//    end.
//

{$B-}

///////////////////////////////////////////////////////
// .L ɋLqꂽꂽ unit/interface/uses
///////////////////////////////////////////////////////

{*******************************************************************************
                                ExpLex
[CZX]
  {\tgEFA LGPL2(not 2.1) ŔzzĂ܂B

  Eۏ
    ύX҂͖{\tgEFA̎gpɋN邠鑹QEQɂĂ̐ӔC
    ؕȂ̂Ƃ܂B܂oOC̋`𕉂Ȃ̂Ƃ܂B
  Egp
    pA񏤗p킸RɎgpĂ܂܂Bgp\Kv܂B
  EA[JCu̕ύX
    ƎA[JCuɊ܂߂čĔzzĂ܂܂B𓾂Kv܂B
  Eϔłzz
    ȉ[ύX]ɕύX_AύX҂L̏ LGPL2 ŔzzĂB

  EĂ͂Ȃ
    {\tgEFA܂͉ϔłCZXύX(LGPL2 ȊO)zz邱ƁB

[ύX]
v1.00   2002/09/29 t_kumagai@ot.olympus.co.jp(http://kuma.webj.net/)
  EVK쐬
*******************************************************************************}

unit ExpLex;

interface

uses Classes, SysUtils, LexLib_Stream, ExpYacc;



///////////////////////////////////////////////////////

type
TLex = class (TLexBase)
    //  TLex ̃oƂ .L Ő錾ϐE֐ǉ
    StringList: TStrings;
    constructor Create;
    destructor Destroy; override;
    function AddString(const S: string): PChar;
    procedure Puts(const S: string);
    procedure Printf(const Fmt: string; Args: array of const);
	function BinToInt(P: PChar): Integer;
	function OctToInt(P: PChar): Integer;

  public
    yacc: TYacc;
    function yylex: Integer; override;
end;

implementation

function TLex.yylex : Integer;

procedure yyaction ( yyruleno : Integer );
begin
    (* actions: *)
  case yyruleno of
  1:
             
		begin
		  Puts('BIN:' + yytext);
		  yylval.yyDouble := BinToInt(PChar(yytext));
		  return(NUMBER);
		end;
  2:
        
		begin
		  Puts('HEX:' + yytext);
		  yylval.yyDouble := StrToInt('$' + Copy(yytext, 1, Length(yytext) - 1));
		  return(NUMBER);
		end;
  3:
           
		begin
		  Puts('HEX:' + yytext);
		  yylval.yyDouble := StrToInt('$' + Copy(yytext, 3, Length(yytext)));
		  return(NUMBER);
		end;
  4:
       
		begin
		  Puts('OCT:' + yytext);
		  yylval.yyDouble := OctToInt(PChar(yytext));
		  return(NUMBER);
		end;
  5:
                              
		begin
		  Puts('NUM:' + yytext);
		  yylval.yyDouble := StrToFloat(yytext);
		  return(NUMBER);
		end;
  6:
                
		begin
		  Puts('IDENT:' + yytext);
          yylval.yyPChar := AddString(yytext);
          return(IDENT)
        end;

  7:
        ;

  8,
  9:
  		begin
		  Puts(yytext);
		  returnc(yytext[1]);
		end;



  end;
end(*yyaction*);

(* DFA table: *)

type YYTRec = record
                cc : set of Char;
                s  : Integer;
              end;

const

yynmarks   = 38;
yynmatches = 38;
yyntrans   = 112;
yynstates  = 34;

yyk : array [1..yynmarks] of Integer = (
  { 0: }
  5,
  { 1: }
  5,
  { 2: }
  5,
  8,
  { 3: }
  6,
  8,
  { 4: }
  5,
  8,
  { 5: }
  5,
  8,
  { 6: }
  8,
  { 7: }
  6,
  8,
  { 8: }
  6,
  8,
  { 9: }
  7,
  8,
  { 10: }
  8,
  { 11: }
  9,
  { 12: }
  { 13: }
  1,
  { 14: }
  5,
  { 15: }
  { 16: }
  2,
  { 17: }
  5,
  { 18: }
  { 19: }
  { 20: }
  6,
  { 21: }
  2,
  6,
  { 22: }
  6,
  { 23: }
  4,
  5,
  { 24: }
  { 25: }
  4,
  5,
  { 26: }
  5,
  { 27: }
  { 28: }
  5,
  6,
  { 29: }
  1,
  { 30: }
  5,
  { 31: }
  3,
  { 32: }
  { 33: }
  5
);

yym : array [1..yynmatches] of Integer = (
{ 0: }
  5,
{ 1: }
  5,
{ 2: }
  5,
  8,
{ 3: }
  6,
  8,
{ 4: }
  5,
  8,
{ 5: }
  5,
  8,
{ 6: }
  8,
{ 7: }
  6,
  8,
{ 8: }
  6,
  8,
{ 9: }
  7,
  8,
{ 10: }
  8,
{ 11: }
  9,
{ 12: }
{ 13: }
  1,
{ 14: }
  5,
{ 15: }
{ 16: }
  2,
{ 17: }
  5,
{ 18: }
{ 19: }
{ 20: }
  6,
{ 21: }
  2,
  6,
{ 22: }
  6,
{ 23: }
  4,
  5,
{ 24: }
{ 25: }
  4,
  5,
{ 26: }
  5,
{ 27: }
{ 28: }
  5,
  6,
{ 29: }
  1,
{ 30: }
  5,
{ 31: }
  3,
{ 32: }
{ 33: }
  5
);

yyt : array [1..yyntrans] of YYTrec = (
{ 0: }
  ( cc: [ #1..#9,#11..#31,'!'..'-','/',':'..'@','['..'`',
            '{'..#255 ]; s: 10),
  ( cc: [ #10 ]; s: 11),
  ( cc: [ ' ' ]; s: 9),
  ( cc: [ '.' ]; s: 6),
  ( cc: [ '0' ]; s: 4),
  ( cc: [ '1' ]; s: 2),
  ( cc: [ '2'..'9' ]; s: 5),
  ( cc: [ 'A'..'D','F','a'..'d','f' ]; s: 3),
  ( cc: [ 'E','e' ]; s: 7),
  ( cc: [ 'G'..'Z','g'..'z' ]; s: 8),
{ 1: }
  ( cc: [ #1..#9,#11..#31,'!'..'-','/',':'..'@','['..'`',
            '{'..#255 ]; s: 10),
  ( cc: [ #10 ]; s: 11),
  ( cc: [ ' ' ]; s: 9),
  ( cc: [ '.' ]; s: 6),
  ( cc: [ '0' ]; s: 4),
  ( cc: [ '1' ]; s: 2),
  ( cc: [ '2'..'9' ]; s: 5),
  ( cc: [ 'A'..'D','F','a'..'d','f' ]; s: 3),
  ( cc: [ 'E','e' ]; s: 7),
  ( cc: [ 'G'..'Z','g'..'z' ]; s: 8),
{ 2: }
  ( cc: [ ',' ]; s: 12),
  ( cc: [ '.' ]; s: 18),
  ( cc: [ '0','1' ]; s: 14),
  ( cc: [ '2'..'9' ]; s: 17),
  ( cc: [ 'A','C','D','F','a','c','d','f' ]; s: 15),
  ( cc: [ 'B','b' ]; s: 13),
  ( cc: [ 'E','e' ]; s: 19),
  ( cc: [ 'H','h' ]; s: 16),
{ 3: }
  ( cc: [ '0'..'9','A'..'F','a'..'f' ]; s: 20),
  ( cc: [ 'G','I'..'Z','_','g','i'..'z' ]; s: 22),
  ( cc: [ 'H','h' ]; s: 21),
{ 4: }
  ( cc: [ ',' ]; s: 12),
  ( cc: [ '.' ]; s: 18),
  ( cc: [ '0','1' ]; s: 23),
  ( cc: [ '2'..'7' ]; s: 25),
  ( cc: [ '8','9' ]; s: 17),
  ( cc: [ 'A','C','D','F','a','c','d','f' ]; s: 15),
  ( cc: [ 'B','b' ]; s: 13),
  ( cc: [ 'E','e' ]; s: 19),
  ( cc: [ 'H','h' ]; s: 16),
  ( cc: [ 'X','x' ]; s: 24),
{ 5: }
  ( cc: [ '.' ]; s: 18),
  ( cc: [ '0'..'9' ]; s: 17),
  ( cc: [ 'A'..'D','F','a'..'d','f' ]; s: 15),
  ( cc: [ 'E','e' ]; s: 19),
  ( cc: [ 'H','h' ]; s: 16),
{ 6: }
  ( cc: [ '0'..'9' ]; s: 26),
{ 7: }
  ( cc: [ '+','-' ]; s: 27),
  ( cc: [ '0'..'9' ]; s: 28),
  ( cc: [ 'A'..'F','a'..'f' ]; s: 20),
  ( cc: [ 'G','I'..'Z','_','g','i'..'z' ]; s: 22),
  ( cc: [ 'H','h' ]; s: 21),
{ 8: }
  ( cc: [ '0'..'9','A'..'Z','_','a'..'z' ]; s: 22),
{ 9: }
{ 10: }
{ 11: }
{ 12: }
  ( cc: [ ',','0','1' ]; s: 12),
  ( cc: [ 'B','b' ]; s: 29),
{ 13: }
  ( cc: [ '0'..'9','A'..'F','a'..'f' ]; s: 15),
  ( cc: [ 'H','h' ]; s: 16),
{ 14: }
  ( cc: [ ',' ]; s: 12),
  ( cc: [ '.' ]; s: 18),
  ( cc: [ '0','1' ]; s: 14),
  ( cc: [ '2'..'9' ]; s: 17),
  ( cc: [ 'A','C','D','F','a','c','d','f' ]; s: 15),
  ( cc: [ 'B','b' ]; s: 13),
  ( cc: [ 'E','e' ]; s: 19),
  ( cc: [ 'H','h' ]; s: 16),
{ 15: }
  ( cc: [ '0'..'9','A'..'F','a'..'f' ]; s: 15),
  ( cc: [ 'H','h' ]; s: 16),
{ 16: }
{ 17: }
  ( cc: [ '.' ]; s: 18),
  ( cc: [ '0'..'9' ]; s: 17),
  ( cc: [ 'A'..'D','F','a'..'d','f' ]; s: 15),
  ( cc: [ 'E','e' ]; s: 19),
  ( cc: [ 'H','h' ]; s: 16),
{ 18: }
  ( cc: [ '0'..'9' ]; s: 26),
{ 19: }
  ( cc: [ '+','-' ]; s: 27),
  ( cc: [ '0'..'9' ]; s: 30),
  ( cc: [ 'A'..'F','a'..'f' ]; s: 15),
  ( cc: [ 'H','h' ]; s: 16),
{ 20: }
  ( cc: [ '0'..'9','A'..'F','a'..'f' ]; s: 20),
  ( cc: [ 'G','I'..'Z','_','g','i'..'z' ]; s: 22),
  ( cc: [ 'H','h' ]; s: 21),
{ 21: }
  ( cc: [ '0'..'9','A'..'Z','_','a'..'z' ]; s: 22),
{ 22: }
  ( cc: [ '0'..'9','A'..'Z','_','a'..'z' ]; s: 22),
{ 23: }
  ( cc: [ ',' ]; s: 12),
  ( cc: [ '.' ]; s: 18),
  ( cc: [ '0','1' ]; s: 23),
  ( cc: [ '2'..'7' ]; s: 25),
  ( cc: [ '8','9' ]; s: 17),
  ( cc: [ 'A','C','D','F','a','c','d','f' ]; s: 15),
  ( cc: [ 'B','b' ]; s: 13),
  ( cc: [ 'E','e' ]; s: 19),
  ( cc: [ 'H','h' ]; s: 16),
{ 24: }
  ( cc: [ '0'..'9','A'..'F','a'..'f' ]; s: 31),
{ 25: }
  ( cc: [ '.' ]; s: 18),
  ( cc: [ '0'..'7' ]; s: 25),
  ( cc: [ '8','9' ]; s: 17),
  ( cc: [ 'A'..'D','F','a'..'d','f' ]; s: 15),
  ( cc: [ 'E','e' ]; s: 19),
  ( cc: [ 'H','h' ]; s: 16),
{ 26: }
  ( cc: [ '0'..'9' ]; s: 26),
  ( cc: [ 'E','e' ]; s: 32),
{ 27: }
  ( cc: [ '0'..'9' ]; s: 33),
{ 28: }
  ( cc: [ '0'..'9' ]; s: 28),
  ( cc: [ 'A'..'F','a'..'f' ]; s: 20),
  ( cc: [ 'G','I'..'Z','_','g','i'..'z' ]; s: 22),
  ( cc: [ 'H','h' ]; s: 21),
{ 29: }
{ 30: }
  ( cc: [ '0'..'9' ]; s: 30),
  ( cc: [ 'A'..'F','a'..'f' ]; s: 15),
  ( cc: [ 'H','h' ]; s: 16),
{ 31: }
  ( cc: [ '0'..'9','A'..'F','a'..'f' ]; s: 31),
{ 32: }
  ( cc: [ '+','-' ]; s: 27),
  ( cc: [ '0'..'9' ]; s: 33),
{ 33: }
  ( cc: [ '0'..'9' ]; s: 33)
);

yykl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 2,
{ 2: } 3,
{ 3: } 5,
{ 4: } 7,
{ 5: } 9,
{ 6: } 11,
{ 7: } 12,
{ 8: } 14,
{ 9: } 16,
{ 10: } 18,
{ 11: } 19,
{ 12: } 20,
{ 13: } 20,
{ 14: } 21,
{ 15: } 22,
{ 16: } 22,
{ 17: } 23,
{ 18: } 24,
{ 19: } 24,
{ 20: } 24,
{ 21: } 25,
{ 22: } 27,
{ 23: } 28,
{ 24: } 30,
{ 25: } 30,
{ 26: } 32,
{ 27: } 33,
{ 28: } 33,
{ 29: } 35,
{ 30: } 36,
{ 31: } 37,
{ 32: } 38,
{ 33: } 38
);

yykh : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 2,
{ 2: } 4,
{ 3: } 6,
{ 4: } 8,
{ 5: } 10,
{ 6: } 11,
{ 7: } 13,
{ 8: } 15,
{ 9: } 17,
{ 10: } 18,
{ 11: } 19,
{ 12: } 19,
{ 13: } 20,
{ 14: } 21,
{ 15: } 21,
{ 16: } 22,
{ 17: } 23,
{ 18: } 23,
{ 19: } 23,
{ 20: } 24,
{ 21: } 26,
{ 22: } 27,
{ 23: } 29,
{ 24: } 29,
{ 25: } 31,
{ 26: } 32,
{ 27: } 32,
{ 28: } 34,
{ 29: } 35,
{ 30: } 36,
{ 31: } 37,
{ 32: } 37,
{ 33: } 38
);

yyml : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 2,
{ 2: } 3,
{ 3: } 5,
{ 4: } 7,
{ 5: } 9,
{ 6: } 11,
{ 7: } 12,
{ 8: } 14,
{ 9: } 16,
{ 10: } 18,
{ 11: } 19,
{ 12: } 20,
{ 13: } 20,
{ 14: } 21,
{ 15: } 22,
{ 16: } 22,
{ 17: } 23,
{ 18: } 24,
{ 19: } 24,
{ 20: } 24,
{ 21: } 25,
{ 22: } 27,
{ 23: } 28,
{ 24: } 30,
{ 25: } 30,
{ 26: } 32,
{ 27: } 33,
{ 28: } 33,
{ 29: } 35,
{ 30: } 36,
{ 31: } 37,
{ 32: } 38,
{ 33: } 38
);

yymh : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 2,
{ 2: } 4,
{ 3: } 6,
{ 4: } 8,
{ 5: } 10,
{ 6: } 11,
{ 7: } 13,
{ 8: } 15,
{ 9: } 17,
{ 10: } 18,
{ 11: } 19,
{ 12: } 19,
{ 13: } 20,
{ 14: } 21,
{ 15: } 21,
{ 16: } 22,
{ 17: } 23,
{ 18: } 23,
{ 19: } 23,
{ 20: } 24,
{ 21: } 26,
{ 22: } 27,
{ 23: } 29,
{ 24: } 29,
{ 25: } 31,
{ 26: } 32,
{ 27: } 32,
{ 28: } 34,
{ 29: } 35,
{ 30: } 36,
{ 31: } 37,
{ 32: } 37,
{ 33: } 38
);

yytl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 11,
{ 2: } 21,
{ 3: } 29,
{ 4: } 32,
{ 5: } 42,
{ 6: } 47,
{ 7: } 48,
{ 8: } 53,
{ 9: } 54,
{ 10: } 54,
{ 11: } 54,
{ 12: } 54,
{ 13: } 56,
{ 14: } 58,
{ 15: } 66,
{ 16: } 68,
{ 17: } 68,
{ 18: } 73,
{ 19: } 74,
{ 20: } 78,
{ 21: } 81,
{ 22: } 82,
{ 23: } 83,
{ 24: } 92,
{ 25: } 93,
{ 26: } 99,
{ 27: } 101,
{ 28: } 102,
{ 29: } 106,
{ 30: } 106,
{ 31: } 109,
{ 32: } 110,
{ 33: } 112
);

yyth : array [0..yynstates-1] of Integer = (
{ 0: } 10,
{ 1: } 20,
{ 2: } 28,
{ 3: } 31,
{ 4: } 41,
{ 5: } 46,
{ 6: } 47,
{ 7: } 52,
{ 8: } 53,
{ 9: } 53,
{ 10: } 53,
{ 11: } 53,
{ 12: } 55,
{ 13: } 57,
{ 14: } 65,
{ 15: } 67,
{ 16: } 67,
{ 17: } 72,
{ 18: } 73,
{ 19: } 77,
{ 20: } 80,
{ 21: } 81,
{ 22: } 82,
{ 23: } 91,
{ 24: } 92,
{ 25: } 98,
{ 26: } 100,
{ 27: } 101,
{ 28: } 105,
{ 29: } 105,
{ 30: } 108,
{ 31: } 109,
{ 32: } 111,
{ 33: } 112
);


(* yylex *)
label
    start, scan, action;
var
    yyn : Integer;
begin

start:

  (* initialize: *)

  yynew;

scan:

  (* mark positions and matches: *)

  for yyn := yykl[yystate] to     yykh[yystate] do yymark (yyk[yyn]);
  for yyn := yymh[yystate] downto yyml[yystate] do yymatch(yym[yyn]);

  if yytl[yystate]>yyth[yystate] then goto action; (* dead state *)

  (* get next character: *)

  yyscan;

  (* determine action: *)

  yyn := yytl[yystate];
  while (yyn<=yyth[yystate]) and not (yyactchar in yyt[yyn].cc) do inc(yyn);
  if yyn>yyth[yystate] then goto action;
    (* no transition on yyactchar in this state *)

  (* switch to new state: *)

  yystate := yyt[yyn].s;

  goto scan;

action:

  (* execute action: *)

  if yyfind(yyrule) then begin
    yyaction(yyrule);
    if yyreject then goto action;
  end else
  if not yydefault and yywrap then begin
    yyclear;
    return(0);
  end;

  if not yydone then goto start;

  Result:= yyretval;

end(*yylex*);

    // .L Ő錾 TLex o̎ɒǉ

constructor TLex.Create;
begin
  inherited;
  StringList := TStringList.Create;
end;

destructor TLex.Destroy;
begin
  StringList.Free;
  inherited;
end;

function TLex.AddString(const S: string): PChar;
var
  Index: Integer;
begin
  Index := StringList.IndexOf(S);
  if (Index < 0) then
    StringList.Add(S);
  Result := PChar(StringList[StringList.IndexOf(S)]);
end;

procedure TLex.Puts(const S: string);
begin
  yywriteln(S);
end;

procedure TLex.Printf(const Fmt: string; Args: array of const);
begin
  Puts(Format(Fmt, Args));
end;

function TLex.BinToInt(P: PChar): Integer;
var
  N: Integer;
begin
  N := 0;
  while (P^ <> #0) do
  begin
    if (P^ in ['0', '1']) then
    begin
      N := N shl 1;
      Inc(N, Ord(P^) - Ord('0'));
    end;
    Inc(P);
  end;
  Result := N;
end;

function TLex.OctToInt(P: PChar): Integer;
var
  N: Integer;
begin
  N := 0;
  while (P^ <> #0) do
  begin
    if (P^ in ['0'..'7']) then
    begin
      N := N shl 3;
      Inc(N, Ord(P^) - Ord('0'));
    end;
    Inc(P);
  end;
  Result := N;
end;

end.
