%{
{*******************************************************************************
                                ExpLex
[CZX]
  {\tgEFA LGPL2(not 2.1) ŔzzĂ܂B

  Eۏ
    ύX҂͖{\tgEFA̎gpɋN邠鑹QEQɂĂ̐ӔC
    ؕȂ̂Ƃ܂B܂oOC̋`𕉂Ȃ̂Ƃ܂B
  Egp
    pA񏤗p킸RɎgpĂ܂܂Bgp\Kv܂B
  EA[JCu̕ύX
    ƎA[JCuɊ܂߂čĔzzĂ܂܂B𓾂Kv܂B
  Eϔłzz
    ȉ[ύX]ɕύX_AύX҂L̏ LGPL2 ŔzzĂB

  EĂ͂Ȃ
    {\tgEFA܂͉ϔłCZXύX(LGPL2 ȊO)zz邱ƁB

[ύX]
v1.00   2002/09/29 t_kumagai@ot.olympus.co.jp(http://kuma.webj.net/)
  EVK쐬
*******************************************************************************}

unit ExpLex;

interface

uses Classes, SysUtils, LexLib_Stream, ExpYacc;

%}

A				[A-Za-z]
B				[0-1]
O				[0-7]
D				[0-9]
H				[0-9a-fA-F]

%%
    //  TLex ̃oƂ .L Ő錾ϐE֐ǉ
    StringList: TStrings;
    constructor Create;
    destructor Destroy; override;
    function AddString(const S: string): PChar;
    procedure Puts(const S: string);
    procedure Printf(const Fmt: string; Args: array of const);
	function BinToInt(P: PChar): Integer;
	function OctToInt(P: PChar): Integer;

{B}[01,]*[bB]
		begin
		  Puts('BIN:' + yytext);
		  yylval.yyDouble := BinToInt(PChar(yytext));
		  return(NUMBER);
		end;
{H}+[hH]
		begin
		  Puts('HEX:' + yytext);
		  yylval.yyDouble := StrToInt('$' + Copy(yytext, 1, Length(yytext) - 1));
		  return(NUMBER);
		end;
"0"[xX]{H}+
		begin
		  Puts('HEX:' + yytext);
		  yylval.yyDouble := StrToInt('$' + Copy(yytext, 3, Length(yytext)));
		  return(NUMBER);
		end;
"0"{O}+
		begin
		  Puts('OCT:' + yytext);
		  yylval.yyDouble := OctToInt(PChar(yytext));
		  return(NUMBER);
		end;
{D}*("."{D}+)?([Ee][-+]?{D}+)?
		begin
		  Puts('NUM:' + yytext);
		  yylval.yyDouble := StrToFloat(yytext);
		  return(NUMBER);
		end;
{A}[_a-zA-Z0-9]*
		begin
		  Puts('IDENT:' + yytext);
          yylval.yyPChar := AddString(yytext);
          return(IDENT)
        end;

" "     ;

.		|
\n		begin
		  Puts(yytext);
		  returnc(yytext[1]);
		end;



%%
    // .L Ő錾 TLex o̎ɒǉ

constructor TLex.Create;
begin
  inherited;
  StringList := TStringList.Create;
end;

destructor TLex.Destroy;
begin
  StringList.Free;
  inherited;
end;

function TLex.AddString(const S: string): PChar;
var
  Index: Integer;
begin
  Index := StringList.IndexOf(S);
  if (Index < 0) then
    StringList.Add(S);
  Result := PChar(StringList[StringList.IndexOf(S)]);
end;

procedure TLex.Puts(const S: string);
begin
  yywriteln(S);
end;

procedure TLex.Printf(const Fmt: string; Args: array of const);
begin
  Puts(Format(Fmt, Args));
end;

function TLex.BinToInt(P: PChar): Integer;
var
  N: Integer;
begin
  N := 0;
  while (P^ <> #0) do
  begin
    if (P^ in ['0', '1']) then
    begin
      N := N shl 1;
      Inc(N, Ord(P^) - Ord('0'));
    end;
    Inc(P);
  end;
  Result := N;
end;

function TLex.OctToInt(P: PChar): Integer;
var
  N: Integer;
begin
  N := 0;
  while (P^ <> #0) do
  begin
    if (P^ in ['0'..'7']) then
    begin
      N := N shl 3;
      Inc(N, Ord(P^) - Ord('0'));
    end;
    Inc(P);
  end;
  Result := N;
end;

end.
